shlib.sh: only parse locale -a output at install time
[girocco.git] / shlib.sh
blob8ecfde3edf3b1d7aa8cc5e8d96bab595f2ea3c25
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 # SHA-1 pattern
7 octet='[0-9a-f][0-9a-f]'
8 octet4="$octet$octet$octet$octet"
9 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20="$octet4$octet4$octet4$octet4$octet4"
11 # tab
12 tab="$(printf '\t')"
14 vcmp() {
15 # Compare $1 to $2 each of which must match \d+(\.\d+)*
16 # An empty string ('') for $1 or $2 is treated like 0
17 # Outputs:
18 # -1 if $1 < $2
19 # 0 if $1 = $2
20 # 1 if $1 > $2
21 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
22 while
23 _a="${1%%.*}"
24 _b="${2%%.*}"
25 [ -n "$_a" -o -n "$_b" ]
27 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
28 echo -1
29 return
30 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
31 echo 1
32 return
34 _a2="${1#$_a}"
35 _b2="${2#$_b}"
36 set -- "${_a2#.}" "${_b2#.}"
37 done
38 echo 0
41 get_girocco_config_pm_var_list() {
42 # Export all the variables from Girocco::Config to suitable var= lines
43 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
44 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
45 __girocco_conf="$GIROCCO_CONF"
46 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
47 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
48 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
49 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
50 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
51 $val =~ s/([\\"\$\`])/\\$1/gos;
52 $val =~ s/(?:\r\n|\r|\n)$//os;
53 print "cfg_$_=\"$val\"";
54 print "defined_cfg_$_=",
55 (defined(${$Girocco::Config::{$_}})?"1":"");
59 get_girocco_config_var_list() (
60 # Same as get_girocco_config_pm_var_list except that
61 # the following variables (all starting with var_) are added:
62 # var_git_ver The version number part from `git version`
63 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
64 # var_window_memory Value to use for repack --window-memory=
65 # var_log_window_size Value to use for git-svn --log-window-size=
66 # var_utf8_locale Value to use for a UTF-8 locale if available
67 _cfg_vars="$(get_girocco_config_pm_var_list)"
68 eval "$_cfg_vars"
69 printf '%s\n' "$_cfg_vars"
70 _gver="$("$cfg_git_bin" version 2>/dev/null | \
71 sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
72 printf 'var_git_ver=%s\n' "$_gver"
73 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
74 __girocco_conf="$GIROCCO_CONF"
75 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
76 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
77 printf "var_window_memory=%s\n" \
78 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
79 -MGirocco::Util -e 'print calc_windowmemory')"
80 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
81 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
82 _guess_locale="$(locale -a | grep -viE '^(posix|c)(\..*)?$' | \
83 grep -iE '\.utf-?8$' | sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
84 sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
85 head -n 1 | cut -d ' ' -f 2)"
86 [ -z "$_guess_locale" ] || printf 'var_utf8_locale=%s.UTF-8\n' "$_guess_locale"
89 # If basedir has been replaced, and shlib_vars.sh exists, get the config
90 # definitions from it rather than running Perl.
91 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
92 # Import all the variables from Girocco::Config to the local environment,
93 eval "$(get_girocco_config_var_list)"
94 else
95 # Import the variables from shlib_vars.sh which avoids needlessly
96 # running another copy of Perl
97 . "@basedir@/shlib_vars.sh"
100 # Make sure we have a reproducible environment by using a controlled HOME dir
101 XDG_CONFIG_HOME="$cfg_chroot/var/empty"
102 HOME="$cfg_chroot/etc/girocco"
103 GIT_CONFIG_NOSYSTEM=1
104 GIT_ATTR_NOSYSTEM=1
105 GIT_NO_REPLACE_OBJECTS=1
106 GIT_TERMINAL_PROMPT=0
107 GIT_ASKPASS="$cfg_basedir/bin/git-askpass-password"
108 export XDG_CONFIG_HOME
109 export HOME
110 export GIT_CONFIG_NOSYSTEM
111 export GIT_ATTR_NOSYSTEM
112 export GIT_NO_REPLACE_OBJECTS
113 export GIT_TERMINAL_PROMPT
114 export GIT_ASKPASS
115 unset GIT_USER_AGENT
116 unset GIT_HTTP_USER_AGENT
117 if [ -n "$defined_cfg_git_client_ua" ]; then
118 GIT_USER_AGENT="$cfg_git_client_ua"
119 export GIT_USER_AGENT
120 GIT_HTTP_USER_AGENT="$cfg_git_client_ua"
121 export GIT_HTTP_USER_AGENT
124 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
125 # and nc_openbsd to the desired executables because when using
126 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
127 # different and unexpected ways:
128 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
129 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
130 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
131 # None of these are good. We want a temporary "export ENV_VAR=xxx"
132 # setting only while running func which none of the /bin/sh's do.
134 # Instead we'd like to use an alias that provides the desired behavior without
135 # any of the bad (a), (b) or (c) effects.
137 # However, unfortunately, some of the crazy /bin/sh implementations do not
138 # recognize alias expansions when preceded by variable assignments!
140 # So we are left with git() {} and nc_openbsd() {} functions and in the
141 # case of git() {} we can compensate for (b) and (c) failing to export
142 # but not (a) and (b) persisting the values so the caller will simply
143 # have to beware and explicitly unset any variables that should not persist
144 # beyond the function call itself.
146 git() (
147 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
148 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
149 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
150 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
151 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
152 exec "$cfg_git_bin" "$@"
155 nc_openbsd() { "$cfg_nc_openbsd_bin" "$@"; }
157 _addrlist() {
158 _list=
159 for _addr in "$@"; do
160 [ -z "$_list" ] || _list="$_list, "
161 _list="$_list$_addr"
162 done
163 echo "$_list"
166 _sendmail() {
167 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
168 if [ -n "$cfg_sender" ]; then
169 "$_mailer" -i -f "$cfg_sender" "$@"
170 else
171 "$_mailer" -i "$@"
175 mail() {
176 _subject=
177 if [ "$1" = "-s" ]; then
178 shift
179 _subject="$1"
180 shift
183 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
184 echo "To: $(_addrlist "$@")"
185 [ -z "$_subject" ] || echo "Subject: $_subject"
186 echo "MIME-Version: 1.0"
187 echo "Content-Type: text/plain; charset=utf-8"
188 echo "Content-Transfer-Encoding: 8bit"
189 echo "Auto-Submitted: auto-generated"
190 echo ""
192 } | _sendmail "$@"
195 # bang CMD... will execute the command with well-defined failure mode;
196 # set bang_action to string of the failed action ('clone', 'update', ...);
197 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
198 # not spam the owner; re-define the bang_trap() function to do custom
199 # cleanup before bailing out
200 bang() {
201 if [ -n "$show_progress" ]; then
202 exec 3>&1
203 errcode=
204 read -r errcode <<-EOT || :
206 exec 4>&3 3>&1 1>&4 4>&-
207 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
210 exec 3>&-
211 if [ -z "$errcode" ]; then
212 # All right. Cool.
213 return;
215 else
216 if "$@" >>"$bang_log" 2>&1; then
217 # All right. Cool.
218 return;
219 else
220 errcode="$?"
223 if ! [ -e .banged ] || [ -e .bangagain ]; then
224 rm -f .bangagain
225 bangmailok=true
226 ! [ -f HEAD -a -f config -a -d objects ] ||
227 bangmailok="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
228 bangaddrs=''
229 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs="$mail"
230 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
231 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
232 [ -z "$bangaddrs" ] ||
234 echo "$* failed with error code $errcode"
235 echo ""
236 [ ! -n "$bang_once" ] || echo "you will not receive any more notifications until recovery"
237 echo "this status message may be disabled on the project admin page"
238 echo ""
239 echo "Log follows:"
240 echo ""
241 cat "$bang_log"
242 } | mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
244 touch .banged
245 cat "$bang_log" > .banglog
246 bang_trap
247 exit 1
250 # bang_eval CMD... will evaluate the command with well-defined failure mode;
251 # Identical to bang CMD... except the command is eval'd instead of executed.
252 bang_eval() {
253 bang eval "$*"
256 # Default bang settings:
257 bang_setup() {
258 bang_action="lame_programmer"
259 bang_once=
260 bang_trap() { :; }
261 bang_log="$(mktemp -t repomgr-XXXXXX)"
262 trap 'rm -f "$bang_log"' EXIT
263 trap 'exit 130' INT
264 trap 'exit 143' TERM
267 # Remove banged status
268 bang_reset() {
269 rm -f .banged .bangagain .banglog
272 # Check to see if banged status
273 is_banged() {
274 [ -e .banged ]
278 # Progress report - if show_progress is set, shows the given message.
279 progress() {
280 [ ! -n "$show_progress" ] || echo "$@"
284 # Project config accessors; must be run in project directory
285 config_get() {
286 git config "gitweb.$1"
289 config_set() {
290 git config "gitweb.$1" "$2" && chgrp repo config && chmod g+w config
293 config_set_raw() {
294 git config "$1" "$2" && chgrp repo config && chmod g+w config
297 config_get_date_seconds() {
298 _dt="$(config_get "$1" || :)"
299 [ -n "$_dt" ] || return 1
300 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date('$_dt')")"
301 [ -n "$_ds" ] || return 1
302 echo "$_ds"
305 # Tool for checking whether given number of seconds has not passed yet
306 check_interval() {
307 os="$(config_get_date_seconds "$1")" || return 1
308 ns="$(date +%s)"
309 [ $ns -lt $(($os+$2)) ]
312 # Check to see if the single argument is a Git directory
313 is_git_dir() {
314 # Just like Git's test except we ignore GIT_OBJECT_DIRECTORY
315 # And we are slightly more picky (must be refs/.+ not refs/.*)
316 [ -d "$1/objects" -a -x "$1/objects" ] || return 1
317 [ -d "$1/refs" -a -x "$1/refs" ] || return 1
318 if [ -L "$1/HEAD" ]; then
319 _hr="$(readlink "$1/HEAD")"
320 case "$_hr" in "refs/"?*) :;; *) return 1;; esac
322 [ -f "$1/HEAD" -a -r "$1/HEAD" ] || return 1
323 read -r _hr <"$1/HEAD" || return 1
324 case "$_hr" in
325 $octet20)
326 return 0;;
327 ref:*)
328 _hr="${_hr##ref:*[ $tab]}"
329 case "$_hr" in "refs/"?*) return 0;; esac
330 esac
331 return 1
334 # List all Git repositories, with given prefix if specified, one-per-line
335 # All project names starting with _ are always excluded from the result
336 get_repo_list() {
337 if [ -n "$1" ]; then
338 cut -d : -f 1,3 "$cfg_chroot"/etc/group | grep "^$1"
339 else
340 cut -d : -f 1,3 "$cfg_chroot"/etc/group
341 fi | while IFS=: read name id; do
342 [ $id -lt 65536 ] || case "$name" in _*) :;; ?*) echo "$name"; esac
343 done
346 # returns empty string for non-mirrors, otherwise one of:
347 # m => normal Git mirror
348 # s => mirror from svn source
349 # d => mirror from darcs source
350 # b => mirror from bzr source
351 # h => mirror from hg source
352 # the optional passed in git dir defaults to "."
353 # will fail if the directory does not have .nofetch and gitweb.baseurl
354 # comes back empty
355 get_mirror_type() {
356 _gitdir="${1:-.}"
357 # always return empty for non-mirrors
358 [ ! -e "$_gitdir/.nofetch" ] || return 0
359 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
360 _url="${_url##* }"
361 case "$_url" in
363 return 1
365 svn://* | svn+http://* | svn+https://*)
366 echo 's'
368 darcs://*)
369 echo 'd'
371 bzr://*)
372 echo 'b'
374 hg+http://* | hg+https://*)
375 echo 'h'
378 echo 'm'
380 esac
381 return 0
384 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
385 is_gfi_mirror() {
386 case "$(get_mirror_type "$1" 2>/dev/null || :)" in
387 d|b|h)
388 # darcs, bzr and hg mirrors use git fast-import
389 return 0
392 # Don't think git-svn currently uses git fast-import
393 # And Git mirrors certainly do not
394 return 1
396 esac
397 # assume it does not use git fast-import
398 return 1
401 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
402 is_svn_mirror() {
403 [ "$(get_mirror_type "$1" 2>/dev/null || :)" = "s" ]
406 # A well-known UTF-8 locale is required for some of the fast-import providers
407 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
408 # but that is not reliably UTF-8 but rather usually US-ASCII.
409 # We parse the output of `locale -a` and select a suitable UTF-8 locale at
410 # install time and store that in $var_utf8_locale if one is found.
411 # If we cannot find one in the `locale -a` output then we just use a well-known
412 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
413 # it. We only set this temporarily when running the fast-import providers.
414 set_utf8_locale() {
415 LC_ALL="${var_utf8_locale:-en_US.UTF-8}"
416 export LC_ALL
419 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
420 git_hg_fetch() (
421 set_utf8_locale
422 _python="${PYTHON:-python}"
423 _err1=
424 _err2=
425 exec 3>&1
426 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
428 exec 4>&3 3>&1 1>&4 4>&-
430 _e1=0
431 [ -f hg2git-marks ] || touch hg2git-marks
432 _af="$(git config hg.authorsfile || :)"
433 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
434 --repo "$(pwd)/repo.hg" \
435 --marks "$(pwd)/hg2git-marks" \
436 --mapping "$(pwd)/hg2git-mapping" \
437 --heads "$(pwd)/hg2git-heads" \
438 --status "$(pwd)/hg2git-state" \
439 -U unknown --force --flatten --hg-hash'
440 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
441 eval "$_cmd" 3>&- || _e1=$?
442 echo $_e1 >&3
443 } | \
445 _e2=0
446 rm -f hg2git-marks.new
447 git fast-import \
448 --export-marks="$(pwd)/hg2git-marks.new" \
449 --export-pack-edges="$(pwd)/gfi-packs" \
450 --force 3>&- || _e2=$?
451 echo $_e2 >&3
455 exec 3>&-
456 [ "$_err1" = 0 -a "$_err2" = 0 ] || return 1
457 if [ -f hg2git-marks ]; then
458 rm -f hg2git-marks.old
459 mv hg2git-marks hg2git-marks.old
460 else
461 touch hg2git-marks.old
463 cat hg2git-marks.old hg2git-marks.new | \
464 LC_ALL=C sort -t : -k2,2n -u | \
465 sed -ne "/^:[1-9][0-9]* $octet20\$/p" > hg2git-marks
466 rm hg2git-marks.old hg2git-marks.new
467 rm -f hg2git-heads
468 git branch --no-color | \
469 while IFS= read -r _head; do
470 echo ":${_head#??} $(git rev-parse "refs/heads/${_head#??}")"
471 done > hg2git-heads